/****************************************
*  Computer Algebra System SINGULAR     *
****************************************/
/* $Id: mminit.cc,v 1.12.2.1 1998/10/01 11:35:29 pohl Exp $ */
/*
* ABSTRACT: init of memory management
*/

#define _POSIX_SOURCE 1

#include <stdlib.h>
#include <string.h>
#define __USE_MISC
#include <unistd.h>
#ifdef macintosh
#include <types.h>
#else
#include <sys/types.h>
#endif
#include "omalloc.h"
#include "mmprivat.h"
extern "C" {
#include <gmp.h>
}

#ifdef ALIGN_8
mcb mm_normList[MAXLIST]=
{ NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL};
;
mcb mm_tmpList[MAXLIST]=
{ NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL};
#else
mcb mm_normList[MAXLIST]=
{ NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL};
mcb mm_tmpList[MAXLIST]=
{ NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,
  NULL,NULL};
#endif


mcb *mm_theList=mm_normList;

status_t mm_status = MM_NORMAL;

int mm_bytesUsed=0;
int mm_bytesReal=0;
int mm_bytesTmp=0;
int mm_bytesNorm=0;

int mm_specIndex=0;
size_t mm_specSize = 0;

int mm_printMark=102400;

#if 0
void* operator new ( size_t size )
{
  return AllocL( size );
}

void operator delete ( void* block )
{
  FreeL( block );
}
#endif

#ifdef HAVE_SBRK
#include <unistd.h>
unsigned long mm_SbrkInit = (unsigned long)sbrk(0);
#endif

int xmmInit();
static int xmmIsInitialized=xmmInit();

int om_sing_opt_show_mem; /* dummy */
struct omInfo_s om_Info; /* dummy */
struct omOpts_s om_Opts; /* dummy */

int xmmInit( void )
{
  if(xmmIsInitialized==0)
  {
    mp_set_memory_functions(mmAllocBlock,mmReallocBlock,mmFreeBlock);
  }
  xmmIsInitialized=1;
  return 1;
}
